(function() {
    "use strict";
    function $$utils$$clear(parentNode, firstNode, lastNode) {
      if (!parentNode) { return; }

      var node = firstNode;
      var nextNode;
      do {
        nextNode = node.nextSibling;
        parentNode.removeChild(node);
        if (node === lastNode) {
          break;
        }
        node = nextNode;
      } while (node);
    }

    function $$utils$$insertBefore(parentNode, firstNode, lastNode, refNode) {
      var node = firstNode;
      var nextNode;
      do {
        nextNode = node.nextSibling;
        parentNode.insertBefore(node, refNode);
        if (node === lastNode) {
          break;
        }
        node = nextNode;
      } while (node);
    }

    function $$morph$list$$MorphList() {
      // morph graph
      this.firstChildMorph = null;
      this.lastChildMorph  = null;

      this.mountedMorph = null;
    }

    var $$morph$list$$prototype = $$morph$list$$MorphList.prototype;

    $$morph$list$$prototype.clear = function MorphList$clear() {
      var current = this.firstChildMorph;

      while (current) {
        var next = current.nextMorph;
        current.previousMorph = null;
        current.nextMorph = null;
        current.parentMorphList = null;
        current = next;
      }

      this.firstChildMorph = this.lastChildMorph = null;
    };

    $$morph$list$$prototype.destroy = function MorphList$destroy() {
    };

    $$morph$list$$prototype.appendMorph = function MorphList$appendMorph(morph) {
      this.insertBeforeMorph(morph, null);
    };

    $$morph$list$$prototype.insertBeforeMorph = function MorphList$insertBeforeMorph(morph, referenceMorph) {
      if (morph.parentMorphList !== null) {
        morph.unlink();
      }
      if (referenceMorph && referenceMorph.parentMorphList !== this) {
        throw new Error('The morph before which the new morph is to be inserted is not a child of this morph.');
      }

      var mountedMorph = this.mountedMorph;

      if (mountedMorph) {

        var parentNode = mountedMorph.firstNode.parentNode;
        var referenceNode = referenceMorph ? referenceMorph.firstNode : mountedMorph.lastNode.nextSibling;

        $$utils$$insertBefore(
          parentNode,
          morph.firstNode,
          morph.lastNode,
          referenceNode
        );

        // was not in list mode replace current content
        if (!this.firstChildMorph) {
          $$utils$$clear(this.mountedMorph.firstNode.parentNode,
                this.mountedMorph.firstNode,
                this.mountedMorph.lastNode);
        }
      }

      morph.parentMorphList = this;

      var previousMorph = referenceMorph ? referenceMorph.previousMorph : this.lastChildMorph;
      if (previousMorph) {
        previousMorph.nextMorph = morph;
        morph.previousMorph = previousMorph;
      } else {
        this.firstChildMorph = morph;
      }

      if (referenceMorph) {
        referenceMorph.previousMorph = morph;
        morph.nextMorph = referenceMorph;
      } else {
        this.lastChildMorph = morph;
      }

      this.firstChildMorph._syncFirstNode();
      this.lastChildMorph._syncLastNode();
    };

    $$morph$list$$prototype.removeChildMorph = function MorphList$removeChildMorph(morph) {
      if (morph.parentMorphList !== this) {
        throw new Error("Cannot remove a morph from a parent it is not inside of");
      }

      morph.destroy();
    };

    var $$morph$list$$default = $$morph$list$$MorphList;

    (function (root, factory) {
      if (typeof define === 'function' && define.amd) {
        define([], factory);
      } else if (typeof exports === 'object') {
        module.exports = factory();
      } else {
        root.MorphList = factory();
      }
    }(this, function () {
      return $$morph$list$$default;
    }));
}).call(this);

//# sourceMappingURL=morph-list.js.map